package com.steerinfo.dil.mapper;

import com.steerinfo.dil.model.AmsshipDeliveryAttorney;
import com.steerinfo.dil.model.AmsshipDeliveryNotice;
import com.steerinfo.framework.mapper.IBaseMapper;
import org.apache.ibatis.annotations.MapKey;
import org.apache.ibatis.annotations.Mapper;
import org.apache.ibatis.annotations.Select;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

@Mapper
public interface AmsshipDeliveryAttorneyMapper extends IBaseMapper<AmsshipDeliveryAttorney, BigDecimal> {
    @MapKey("selectshipCargoTranferResult")
    List<Map<String,Object>> selectshipCargoTranferResult(Map<String,Object> mapVal);
    //添加提货委托信息
//    int insert(AmsshipDeliveryAttorney amsshipDeliveryAttorney);
    //删除提货委托信息
    int deleteByPrimaryKey(BigDecimal attorneyId);
    //修改提货委托信息
    int updateByPrimaryKey(BigDecimal attorneyId);
    BigDecimal selectMaxId();
    //  根据关键字查找信息
    AmsshipDeliveryAttorney selectByPrimaryKey(BigDecimal attorneyId);
    List<Map<String,Object>> getPortName();
    List<Map<String,Object>> getNoticeId();
    List<Map<String,Object>> getDeliveryAttorneyId(Integer attorneyId);
    /**
     * 查询AttorneyId
     * @return
     */
    List<Map<String, Object>> getAttorneyId();

    /**
     * 查询PortId
     * @return
     */
    List<Map<String, Object>> getPortId();

    /**
     * 查询PierId
     * @return
     */
    List<Map<String, Object>> getPierId();

    /**
     * 仓库id
     * @return
     */
    List<Map<String, Object>> getRmRawId();

    @Select("select seq_AMSSHIP_ATTORNEY.nextval from dual")
    BigDecimal selectAttorneyId();
}