package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="提货委托书")
public class AmsshipDeliveryAttorney implements IBasePO<BigDecimal> {
    /**
     * 主键ID(ATTORNEY_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal attorneyId;

    /**
     * 批次ID(BATCH_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="批次ID",required=false)
    private BigDecimal batchId;

    /**
     * 物流流向即到站港(PORT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="物流流向即到站港",required=false)
    private BigDecimal portId;

    /**
     * 提货单位（下游港口ID）(DOWN_SWIM_PORT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="提货单位（下游港口ID）",required=false)
    private BigDecimal downSwimPortId;

    /**
     * 提货联系人(ATTORNEY_PICKUP_CONTACT_PERSON,VARCHAR,20)
     */
    @ApiModelProperty(value="提货联系人",required=false)
    private String attorneyPickupContactPerson;

    /**
     * 提货人身份证号(ATTORENY_PICKUP_IDCARD,VARCHAR,50)
     */
    @ApiModelProperty(value="提货人身份证号",required=false)
    private String attorenyPickupIdcard;

    /**
     * 联系电话(ATTORNEY_CONTACT_TELEPHONE,VARCHAR,20)
     */
    @ApiModelProperty(value="联系电话",required=false)
    private String attorneyContactTelephone;

    /**
     * 委托时间(ATTORNEY_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="委托时间",required=false)
    private Date attorneyTime;

    /**
     * PDF文件(ATTORNEY_PDFFILE,VARCHAR,20)
     */
    @ApiModelProperty(value="PDF文件",required=false)
    private String attorneyPdffile;

    /**
     * 废除人(DELETE_NAME,VARCHAR,16)
     */
    @ApiModelProperty(value="废除人",required=false)
    private String deleteName;

    /**
     * 废除时间(DELETE_TIME,VARCHAR,14)
     */
    @ApiModelProperty(value="废除时间",required=false)
    private String deleteTime;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 是否删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="是否删除",required=false)
    private Short deleted;

    /**
     * 下发状态(ATTORNEY_DISTRIBUTION_STATUS,VARCHAR,20)
     */
    @ApiModelProperty(value="下发状态",required=false)
    private String attorneyDistributionStatus;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.attorneyId;
    }

    @Override
    public void setId(BigDecimal attorneyId) {
        this.attorneyId = attorneyId;
    }

    public BigDecimal getAttorneyId() {
        return attorneyId;
    }

    public void setAttorneyId(BigDecimal attorneyId) {
        this.attorneyId = attorneyId;
    }

    public BigDecimal getBatchId() {
        return batchId;
    }

    public void setBatchId(BigDecimal batchId) {
        this.batchId = batchId;
    }

    public BigDecimal getPortId() {
        return portId;
    }

    public void setPortId(BigDecimal portId) {
        this.portId = portId;
    }

    public BigDecimal getDownSwimPortId() {
        return downSwimPortId;
    }

    public void setDownSwimPortId(BigDecimal downSwimPortId) {
        this.downSwimPortId = downSwimPortId;
    }

    public String getAttorneyPickupContactPerson() {
        return attorneyPickupContactPerson;
    }

    public void setAttorneyPickupContactPerson(String attorneyPickupContactPerson) {
        this.attorneyPickupContactPerson = attorneyPickupContactPerson == null ? null : attorneyPickupContactPerson.trim();
    }

    public String getAttorenyPickupIdcard() {
        return attorenyPickupIdcard;
    }

    public void setAttorenyPickupIdcard(String attorenyPickupIdcard) {
        this.attorenyPickupIdcard = attorenyPickupIdcard == null ? null : attorenyPickupIdcard.trim();
    }

    public String getAttorneyContactTelephone() {
        return attorneyContactTelephone;
    }

    public void setAttorneyContactTelephone(String attorneyContactTelephone) {
        this.attorneyContactTelephone = attorneyContactTelephone == null ? null : attorneyContactTelephone.trim();
    }

    public Date getAttorneyTime() {
        return attorneyTime;
    }

    public void setAttorneyTime(Date attorneyTime) {
        this.attorneyTime = attorneyTime;
    }

    public String getAttorneyPdffile() {
        return attorneyPdffile;
    }

    public void setAttorneyPdffile(String attorneyPdffile) {
        this.attorneyPdffile = attorneyPdffile == null ? null : attorneyPdffile.trim();
    }

    public String getAttorneyDistributionStatus() {
        return attorneyDistributionStatus;
    }

    public void setAttorneyDistributionStatus(String attorneyDistributionStatus) {
        this.attorneyDistributionStatus = attorneyDistributionStatus;
    }

    public String getDeleteName() {
        return deleteName;
    }

    public void setDeleteName(String deleteName) {
        this.deleteName = deleteName == null ? null : deleteName.trim();
    }

    public String getDeleteTime() {
        return deleteTime;
    }

    public void setDeleteTime(String deleteTime) {
        this.deleteTime = deleteTime == null ? null : deleteTime.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public Short getDeleted() {
        return deleted;
    }

    public void setDeleted(Short deleted) {
        this.deleted = deleted;
    }


    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", attorneyId=").append(attorneyId);
        sb.append(", batchId=").append(batchId);
        sb.append(", portId=").append(portId);
        sb.append(", downSwimPortId=").append(downSwimPortId);
        sb.append(", attorneyPickupContactPerson=").append(attorneyPickupContactPerson);
        sb.append(", attorenyPickupIdcard=").append(attorenyPickupIdcard);
        sb.append(", attorneyContactTelephone=").append(attorneyContactTelephone);
        sb.append(", attorneyTime=").append(attorneyTime);
        sb.append(", attorneyPdffile=").append(attorneyPdffile);
        sb.append(", deleteName=").append(deleteName);
        sb.append(", deleteTime=").append(deleteTime);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", attorneyDistributionStatus=").append(attorneyDistributionStatus);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}