package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="放货通知单")
public class AmsshipDeliveryNotice implements IBasePO<BigDecimal> {
    /**
     * 主键ID(NOTICE_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal noticeId;

    /**
     * 委托单位ID(REQUESTER_GROUP_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="委托单位ID",required=false)
    private BigDecimal requesterGroupId;

    /**
     * 承运单位ID(CARRIER_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="承运单位ID",required=false)
    private BigDecimal carrierId;

    /**
     * 贸易方式(NOTICE_COMMERCE_METHOD,VARCHAR,20)
     */
    @ApiModelProperty(value="贸易方式",required=false)
    private String noticeCommerceMethod;

    /**
     * 交接方式(NOTICE_HANDOVER_METHOD,VARCHAR,20)
     */
    @ApiModelProperty(value="交接方式",required=false)
    private String noticeHandoverMethod;

    /**
     * 发货港口(PORT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="发货港口",required=false)
    private BigDecimal portId;

    /**
     * 港建费金额(NOTICE_PORT_CONSTRUCTION_FEE,DECIMAL,0)
     */
    @ApiModelProperty(value="港建费金额",required=false)
    private Short noticePortConstructionFee;

    /**
     * 放货时间(NOTICE_DELIVERY_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="放货时间",required=false)
    private Date noticeDeliveryTime;

    /**
     * 免堆天数(NOTICE_PILE_FREE_DAYS,DECIMAL,0)
     */
    @ApiModelProperty(value="免堆天数",required=false)
    private Short noticePileFreeDays;

    /**
     * 废除人(DELETE_NAME,VARCHAR,16)
     */
    @ApiModelProperty(value="废除人",required=false)
    private String deleteName;

    /**
     * 废除时间(DELETE_TIME,VARCHAR,14)
     */
    @ApiModelProperty(value="废除时间",required=false)
    private String deleteTime;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 下发状态(NOTICE_DISTRIBUTION_STATUS,VARCHAR,20)
     */
    @ApiModelProperty(value="下发状态",required=false)
    private String noticeDistributionStatus;

    /**
     * 是否删除(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="是否删除",required=false)
    private Short deleted;

    /**
     * 批次Id(BATCH_ID,DECIMAL,0)
     */
    @ApiModelProperty(value="批次Id",required=false)
    private Short batchId;

    /**
     * 单价（从采购合同中获取）(PURCHASE_CONTRACT_UNIT_PRICE,DECIMAL,0)
     */
    @ApiModelProperty(value="单价（从采购合同中获取）",required=false)
    private Short purchaseContractUnitPrice;

    /**
     * 合同水分（从采购合同中获取）(PURCHASE_CONTRACT_MOISTURE,VARCHAR,20)
     */
    @ApiModelProperty(value="合同水分（从采购合同中获取）",required=false)
    private String purchaseContractMoisture;

    /**
     * 品质指标（从采购合同中获取）(PURCHASE_CONTRACT_QUALITYINDEX,VARCHAR,20)
     */
    @ApiModelProperty(value="品质指标（从采购合同中获取）",required=false)
    private String purchaseContractQualityindex;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.noticeId;
    }

    @Override
    public void setId(BigDecimal noticeId) {
        this.noticeId = noticeId;
    }

    public BigDecimal getNoticeId() {
        return noticeId;
    }

    public void setNoticeId(BigDecimal noticeId) {
        this.noticeId = noticeId;
    }

    public BigDecimal getRequesterGroupId() {
        return requesterGroupId;
    }

    public void setRequesterGroupId(BigDecimal requesterGroupId) {
        this.requesterGroupId = requesterGroupId;
    }

    public BigDecimal getCarrierId() {
        return carrierId;
    }

    public void setCarrierId(BigDecimal carrierId) {
        this.carrierId = carrierId;
    }

    public String getNoticeCommerceMethod() {
        return noticeCommerceMethod;
    }

    public void setNoticeCommerceMethod(String noticeCommerceMethod) {
        this.noticeCommerceMethod = noticeCommerceMethod == null ? null : noticeCommerceMethod.trim();
    }

    public String getNoticeHandoverMethod() {
        return noticeHandoverMethod;
    }

    public void setNoticeHandoverMethod(String noticeHandoverMethod) {
        this.noticeHandoverMethod = noticeHandoverMethod == null ? null : noticeHandoverMethod.trim();
    }

    public BigDecimal getPortId() {
        return portId;
    }

    public void setPortId(BigDecimal portId) {
        this.portId = portId;
    }

    public Short getNoticePortConstructionFee() {
        return noticePortConstructionFee;
    }

    public void setNoticePortConstructionFee(Short noticePortConstructionFee) {
        this.noticePortConstructionFee = noticePortConstructionFee;
    }

    public Date getNoticeDeliveryTime() {
        return noticeDeliveryTime;
    }

    public void setNoticeDeliveryTime(Date noticeDeliveryTime) {
        this.noticeDeliveryTime = noticeDeliveryTime;
    }

    public Short getNoticePileFreeDays() {
        return noticePileFreeDays;
    }

    public void setNoticePileFreeDays(Short noticePileFreeDays) {
        this.noticePileFreeDays = noticePileFreeDays;
    }

    public String getDeleteName() {
        return deleteName;
    }

    public void setDeleteName(String deleteName) {
        this.deleteName = deleteName == null ? null : deleteName.trim();
    }

    public String getDeleteTime() {
        return deleteTime;
    }

    public void setDeleteTime(String deleteTime) {
        this.deleteTime = deleteTime == null ? null : deleteTime.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public String getNoticeDistributionStatus() {
        return noticeDistributionStatus;
    }

    public void setNoticeDistributionStatus(String noticeDistributionStatus) {
        this.noticeDistributionStatus = noticeDistributionStatus == null ? null : noticeDistributionStatus.trim();
    }

    public Short getDeleted() {
        return deleted;
    }

    public void setDeleted(Short deleted) {
        this.deleted = deleted;
    }

    public Short getBatchId() {
        return batchId;
    }

    public void setBatchId(Short batchId) {
        this.batchId = batchId;
    }

    public Short getPurchaseContractUnitPrice() {
        return purchaseContractUnitPrice;
    }

    public void setPurchaseContractUnitPrice(Short purchaseContractUnitPrice) {
        this.purchaseContractUnitPrice = purchaseContractUnitPrice;
    }

    public String getPurchaseContractMoisture() {
        return purchaseContractMoisture;
    }

    public void setPurchaseContractMoisture(String purchaseContractMoisture) {
        this.purchaseContractMoisture = purchaseContractMoisture == null ? null : purchaseContractMoisture.trim();
    }

    public String getPurchaseContractQualityindex() {
        return purchaseContractQualityindex;
    }

    public void setPurchaseContractQualityindex(String purchaseContractQualityindex) {
        this.purchaseContractQualityindex = purchaseContractQualityindex == null ? null : purchaseContractQualityindex.trim();
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", noticeId=").append(noticeId);
        sb.append(", requesterGroupId=").append(requesterGroupId);
        sb.append(", carrierId=").append(carrierId);
        sb.append(", noticeCommerceMethod=").append(noticeCommerceMethod);
        sb.append(", noticeHandoverMethod=").append(noticeHandoverMethod);
        sb.append(", portId=").append(portId);
        sb.append(", noticePortConstructionFee=").append(noticePortConstructionFee);
        sb.append(", noticeDeliveryTime=").append(noticeDeliveryTime);
        sb.append(", noticePileFreeDays=").append(noticePileFreeDays);
        sb.append(", deleteName=").append(deleteName);
        sb.append(", deleteTime=").append(deleteTime);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", noticeDistributionStatus=").append(noticeDistributionStatus);
        sb.append(", deleted=").append(deleted);
        sb.append(", batchId=").append(batchId);
        sb.append(", purchaseContractUnitPrice=").append(purchaseContractUnitPrice);
        sb.append(", purchaseContractMoisture=").append(purchaseContractMoisture);
        sb.append(", purchaseContractQualityindex=").append(purchaseContractQualityindex);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}