package com.steerinfo.dil.model;

import com.steerinfo.framework.model.IBasePO;
import io.swagger.annotations.ApiModel;
import io.swagger.annotations.ApiModelProperty;
import java.math.BigDecimal;
import java.util.Date;

@ApiModel(value="船运装船实绩")
public class TmsshipLoadShipResult implements IBasePO<BigDecimal> {
    /**
     * 主键ID(RESULT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="主键ID",required=true)
    private BigDecimal resultId;

    /**
     * 总实绩ID(TOTAL_RESULT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="总实绩ID",required=false)
    private BigDecimal totalResultId;

    /**
     * 起运港(LOCATION_START_PORT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="起运港",required=false)
    private BigDecimal locationStartPortId;

    /**
     * 到达港ID(ARRIVAL_PORT_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="到达港ID",required=false)
    private BigDecimal arrivalPortId;

    /**
     * 批次id(BATCH_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="批次id",required=false)
    private BigDecimal batchId;

    /**
     * 放货日期(RESULT_DELIVERY_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="放货日期",required=false)
    private Date resultDeliveryDate;

    /**
     * 实装数量（吨）(RESULT_ACTUAL_INSTALLATIONS,DECIMAL,0)
     */
    @ApiModelProperty(value="实装数量（吨）",required=false)
    private BigDecimal resultActualInstallations;

    /**
     * 实绩编号(RESULT_NUMBER,VARCHAR,20)
     */
    @ApiModelProperty(value="实绩编号",required=false)
    private String resultNumber;

    /**
     * 原料港存库实时库存ID(RWAREHOUSE_MATERIAL_ID,DECIMAL,38)
     */
    @ApiModelProperty(value="原料港存库实时库存ID",required=false)
    private BigDecimal rwarehouseMaterialId;

    /**
     * 抵港时间(RESULT_ARRIVAL_PORT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="抵港时间",required=false)
    private Date resultArrivalPortTime;

    /**
     * 离港时间(RESULT_OUT_PORT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="离港时间",required=false)
    private Date resultOutPortTime;

    /**
     * 装船日期(RESULT_LOAD_SHIP_DATE,TIMESTAMP,7)
     */
    @ApiModelProperty(value="装船日期",required=false)
    private Date resultLoadShipDate;

    /**
     * 是否清场（没清场；清场）(RESULT_ISCLEAR,VARCHAR,20)
     */
    @ApiModelProperty(value="是否清场（没清场；清场）",required=false)
    private String resultIsclear;

    /**
     * 废除人(DELETE_NAME,VARCHAR,16)
     */
    @ApiModelProperty(value="废除人",required=false)
    private String deleteName;

    /**
     * 废除时间(DELETE_TIME,VARCHAR,14)
     */
    @ApiModelProperty(value="废除时间",required=false)
    private String deleteTime;

    /**
     * 记录创建人(INSERT_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录创建人",required=false)
    private String insertUsername;

    /**
     * 记录创建时间(INSERT_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录创建时间",required=false)
    private Date insertTime;

    /**
     * 记录修改人(UPDATE_USERNAME,VARCHAR,20)
     */
    @ApiModelProperty(value="记录修改人",required=false)
    private String updateUsername;

    /**
     * 记录修改时间(UPDATE_TIME,TIMESTAMP,7)
     */
    @ApiModelProperty(value="记录修改时间",required=false)
    private Date updateTime;

    /**
     * 记录创建或修改备注(INSERT_UPDATE_REMARK,VARCHAR,100)
     */
    @ApiModelProperty(value="记录创建或修改备注",required=false)
    private String insertUpdateRemark;

    /**
     * 逻辑删除（0：未删除，1：已删除）(DELETED,DECIMAL,0)
     */
    @ApiModelProperty(value="逻辑删除（0：未删除，1：已删除）",required=false)
    private BigDecimal deleted;

    private static final long serialVersionUID = 1L;

    @Override
    public BigDecimal getId() {
        return this.resultId;
    }

    @Override
    public void setId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getResultId() {
        return resultId;
    }

    public void setResultId(BigDecimal resultId) {
        this.resultId = resultId;
    }

    public BigDecimal getTotalResultId() {
        return totalResultId;
    }

    public void setTotalResultId(BigDecimal totalResultId) {
        this.totalResultId = totalResultId;
    }

    public BigDecimal getLocationStartPortId() {
        return locationStartPortId;
    }

    public void setLocationStartPortId(BigDecimal locationStartPortId) {
        this.locationStartPortId = locationStartPortId;
    }

    public BigDecimal getArrivalPortId() {
        return arrivalPortId;
    }

    public void setArrivalPortId(BigDecimal arrivalPortId) {
        this.arrivalPortId = arrivalPortId;
    }

    public BigDecimal getBatchId() {
        return batchId;
    }

    public void setBatchId(BigDecimal batchId) {
        this.batchId = batchId;
    }

    public Date getResultDeliveryDate() {
        return resultDeliveryDate;
    }

    public void setResultDeliveryDate(Date resultDeliveryDate) {
        this.resultDeliveryDate = resultDeliveryDate;
    }

    public BigDecimal getResultActualInstallations() {
        return resultActualInstallations;
    }

    public void setResultActualInstallations(BigDecimal resultActualInstallations) {
        this.resultActualInstallations = resultActualInstallations;
    }

    public String getResultNumber() {
        return resultNumber;
    }

    public void setResultNumber(String resultNumber) {
        this.resultNumber = resultNumber == null ? null : resultNumber.trim();
    }

    public BigDecimal getRwarehouseMaterialId() {
        return rwarehouseMaterialId;
    }

    public void setRwarehouseMaterialId(BigDecimal rwarehouseMaterialId) {
        this.rwarehouseMaterialId = rwarehouseMaterialId;
    }

    public Date getResultArrivalPortTime() {
        return resultArrivalPortTime;
    }

    public void setResultArrivalPortTime(Date resultArrivalPortTime) {
        this.resultArrivalPortTime = resultArrivalPortTime;
    }

    public Date getResultOutPortTime() {
        return resultOutPortTime;
    }

    public void setResultOutPortTime(Date resultOutPortTime) {
        this.resultOutPortTime = resultOutPortTime;
    }

    public Date getResultLoadShipDate() {
        return resultLoadShipDate;
    }

    public void setResultLoadShipDate(Date resultLoadShipDate) {
        this.resultLoadShipDate = resultLoadShipDate;
    }

    public String getResultIsclear() {
        return resultIsclear;
    }

    public void setResultIsclear(String resultIsclear) {
        this.resultIsclear = resultIsclear == null ? null : resultIsclear.trim();
    }

    public String getDeleteName() {
        return deleteName;
    }

    public void setDeleteName(String deleteName) {
        this.deleteName = deleteName == null ? null : deleteName.trim();
    }

    public String getDeleteTime() {
        return deleteTime;
    }

    public void setDeleteTime(String deleteTime) {
        this.deleteTime = deleteTime == null ? null : deleteTime.trim();
    }

    public String getInsertUsername() {
        return insertUsername;
    }

    public void setInsertUsername(String insertUsername) {
        this.insertUsername = insertUsername == null ? null : insertUsername.trim();
    }

    public Date getInsertTime() {
        return insertTime;
    }

    public void setInsertTime(Date insertTime) {
        this.insertTime = insertTime;
    }

    public String getUpdateUsername() {
        return updateUsername;
    }

    public void setUpdateUsername(String updateUsername) {
        this.updateUsername = updateUsername == null ? null : updateUsername.trim();
    }

    public Date getUpdateTime() {
        return updateTime;
    }

    public void setUpdateTime(Date updateTime) {
        this.updateTime = updateTime;
    }

    public String getInsertUpdateRemark() {
        return insertUpdateRemark;
    }

    public void setInsertUpdateRemark(String insertUpdateRemark) {
        this.insertUpdateRemark = insertUpdateRemark == null ? null : insertUpdateRemark.trim();
    }

    public BigDecimal getDeleted() {
        return deleted;
    }

    public void setDeleted(BigDecimal deleted) {
        this.deleted = deleted;
    }

    @Override
    public String toString() {
        StringBuilder sb = new StringBuilder();
        sb.append(getClass().getSimpleName());
        sb.append(" [");
        sb.append("Hash = ").append(hashCode());
        sb.append(", resultId=").append(resultId);
        sb.append(", totalResultId=").append(totalResultId);
        sb.append(", locationStartPortId=").append(locationStartPortId);
        sb.append(", arrivalPortId=").append(arrivalPortId);
        sb.append(", batchId=").append(batchId);
        sb.append(", resultDeliveryDate=").append(resultDeliveryDate);
        sb.append(", resultActualInstallations=").append(resultActualInstallations);
        sb.append(", resultNumber=").append(resultNumber);
        sb.append(", rwarehouseMaterialId=").append(rwarehouseMaterialId);
        sb.append(", resultArrivalPortTime=").append(resultArrivalPortTime);
        sb.append(", resultOutPortTime=").append(resultOutPortTime);
        sb.append(", resultLoadShipDate=").append(resultLoadShipDate);
        sb.append(", resultIsclear=").append(resultIsclear);
        sb.append(", deleteName=").append(deleteName);
        sb.append(", deleteTime=").append(deleteTime);
        sb.append(", insertUsername=").append(insertUsername);
        sb.append(", insertTime=").append(insertTime);
        sb.append(", updateUsername=").append(updateUsername);
        sb.append(", updateTime=").append(updateTime);
        sb.append(", insertUpdateRemark=").append(insertUpdateRemark);
        sb.append(", deleted=").append(deleted);
        sb.append(", serialVersionUID=").append(serialVersionUID);
        sb.append("]");
        return sb.toString();
    }
}