package com.steerinfo.dil.service;

import com.steerinfo.framework.service.IBaseService;
import com.steerinfo.dil.model.TmsshipWaterQualityResult;

import java.math.BigDecimal;
import java.util.List;
import java.util.Map;

/**
 * TmsshipWaterQualityResult服务接口：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 09:01
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmsshipWaterQualityResult服务接口
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
public interface ITmsshipWaterQualityResultService {
    // 查询最大id
    BigDecimal selectMaxId();

    // 插入
    int insertWaterQualityResult(Map<String,Object> map);

    // 根据主键删除
    int deleteWaterQualityResult(BigDecimal resultId);


    //根据主键查看详细
    TmsshipWaterQualityResult selectWaterQualityResult(BigDecimal resultId);


    // 根据主键修改
    int updateWaterQualityResult(TmsshipWaterQualityResult tmsshipWaterQualityResult);


    /**
     * 查询所有水分检测信息
     * @return
     */
    List<Map<String,Object>> selectWaterQualityList(Map<String,Object> mapVal);

    /**
     * 查询所有水分检测表单
     * @return
     */
    List<Map<String,Object>> getWaterQuality(BigDecimal resultId);

    /**
     * 通过总实绩id获得实际装载重量
     * @param totalResultId
     * @return
     */
    BigDecimal selectRealWeight(BigDecimal totalResultId);

    /**
     * 根据子表id查询指令id
     * @param orderId
     */
    BigDecimal selectInstructionsId(BigDecimal orderId);
}