package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.mapper.AmsshipDeliveryAttorneyMapper;
import com.steerinfo.dil.model.AmsshipDeliveryAttorney;
import com.steerinfo.dil.model.AmsshipDeliveryNotice;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.dil.service.IAmsshipDeliveryAttorneyService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * AmsshipDeliveryAttorney服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:44
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipDeliveryAttorney服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsshipDeliveryAttorneyService")
public class AmsshipDeliveryAttorneyServiceImpl implements IAmsshipDeliveryAttorneyService {

    @Autowired
    private AmsshipDeliveryAttorneyMapper amsshipDeliveryAttorneyMapper;


    @Override
    public List<Map<String, Object>> selectshipCargoTranferResult(Map<String, Object> mapVal) {
        return amsshipDeliveryAttorneyMapper.selectshipCargoTranferResult(mapVal);
    }

    @Override
    public int insert(AmsshipDeliveryAttorney amsshipDeliveryAttorney) {
        BigDecimal attorneyId = amsshipDeliveryAttorneyMapper.selectAttorneyId();
        amsshipDeliveryAttorney.setAttorneyId(attorneyId);

        //  设置常规字段
        amsshipDeliveryAttorney.setAttorneyDistributionStatus("未下发");
        amsshipDeliveryAttorney.setInsertTime(new Date());
        amsshipDeliveryAttorney.setDeleteName(null);
        amsshipDeliveryAttorney.setDeleteTime(null);
        amsshipDeliveryAttorney.setInsertUsername("admin");
        amsshipDeliveryAttorney.setUpdateTime(new Date());
        amsshipDeliveryAttorney.setInsertUpdateRemark("无");
        amsshipDeliveryAttorney.setUpdateUsername("admin");
        amsshipDeliveryAttorney.setDeleted((short) 0);
        return amsshipDeliveryAttorneyMapper.insert(amsshipDeliveryAttorney);

    }

    @Override
    public int deleteByPrimaryKey(BigDecimal attorneyId) {


        return  amsshipDeliveryAttorneyMapper.deleteByPrimaryKey(attorneyId);
    }

    @Override
    public int updateByPrimaryKey(BigDecimal attorneyId) {
        return amsshipDeliveryAttorneyMapper.updateByPrimaryKey(attorneyId);
    }

    @Override
    public BigDecimal selectMaxId() {
        return amsshipDeliveryAttorneyMapper.selectMaxId();
    }

    @Override
    public AmsshipDeliveryAttorney selectByPrimaryKey(BigDecimal attorneyId) {
        return amsshipDeliveryAttorneyMapper.selectByPrimaryKey(attorneyId);
    }

    @Override
    public List<Map<String, Object>> getPortName() {
        return amsshipDeliveryAttorneyMapper.getPortName();
    }

    @Override
    public List<Map<String, Object>> getNoticeId() {
        return amsshipDeliveryAttorneyMapper.getNoticeId();
    }

    @Override
    public int updateByPrimaryKeySelective(AmsshipDeliveryAttorney amsshipDeliveryAttorney) {
        return amsshipDeliveryAttorneyMapper.updateByPrimaryKeySelective(amsshipDeliveryAttorney);
    }

    @Override
    public List<Map<String, Object>> getDeliveryAttorneyId(Integer attorneyId) {
        return amsshipDeliveryAttorneyMapper.getDeliveryAttorneyId(attorneyId);
    }

    /**
     * 得到提货通知单id
     * @return
     */
    @Override
    public List<Map<String, Object>> getAttorneyId() {
        return amsshipDeliveryAttorneyMapper.getAttorneyId();
    }

    /**
     * 得到发件人（港口）id
     * @return
     */
    @Override
    public List<Map<String, Object>> getPortId() {
        return amsshipDeliveryAttorneyMapper.getPortId();
    }

    /**
     * 得到收件人（下游港口）id
     * @return
     */
    @Override
    public List<Map<String, Object>> getPierId() {
        return amsshipDeliveryAttorneyMapper.getPierId();
    }

    @Override
    public List<Map<String, Object>> getRmRawId() {
        return amsshipDeliveryAttorneyMapper.getRmRawId();
    }


}
