package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.model.OmsshipShipmentInstructions;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.dil.model.AmsshipDeliveryNotice;
import com.steerinfo.dil.mapper.AmsshipDeliveryNoticeMapper;
import com.steerinfo.dil.service.IAmsshipDeliveryNoticeService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;

import java.math.BigDecimal;
import java.text.SimpleDateFormat;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * AmsshipDeliveryNotice服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-18 03:54
 * 类描述
 * 修订历史：
 * 日期：2021-08-18
 * 作者：generator
 * 参考：
 * 描述：AmsshipDeliveryNotice服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "amsshipDeliveryNoticeService")
public class AmsshipDeliveryNoticeServiceImpl implements IAmsshipDeliveryNoticeService {

    @Autowired
    private AmsshipDeliveryNoticeMapper amsshipDeliveryNoticeMapper;

    //查询所有数据
    @Override
    public List<Map<String, Object>> selectShipDeliveryNotice(Map<String, Object> mapVal) {
        return amsshipDeliveryNoticeMapper.selectShipDeliveryNotice(mapVal);
    }
    //插入
    @Override
    public int insert(AmsshipDeliveryNotice amsshipDeliveryNotice) {

        BigDecimal noticeId = amsshipDeliveryNoticeMapper.selectNoticeId();
        amsshipDeliveryNotice.setNoticeId(noticeId);
        //  设置常规字段
        amsshipDeliveryNotice.setNoticeDistributionStatus("未下发");
        amsshipDeliveryNotice.setInsertTime(new Date());
        amsshipDeliveryNotice.setDeleteName(null);
        amsshipDeliveryNotice.setDeleteTime(null);
        amsshipDeliveryNotice.setInsertUsername("admin");
        amsshipDeliveryNotice.setUpdateTime(new Date());
        amsshipDeliveryNotice.setInsertUpdateRemark("无");
        amsshipDeliveryNotice.setUpdateUsername("admin");
        amsshipDeliveryNotice.setDeleted((short) 0);
        return amsshipDeliveryNoticeMapper.insert(amsshipDeliveryNotice);
    }

    @Override
    public int deleteByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.deleteByPrimaryKey(noticeId);
    }

    @Override
    public int updateByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.updateByPrimaryKey(noticeId);
    }

    @Override
    public BigDecimal selectMaxId() {
        return amsshipDeliveryNoticeMapper.selectMaxId();
    }

    @Override
    public AmsshipDeliveryNotice selectByPrimaryKey(BigDecimal noticeId) {
        return amsshipDeliveryNoticeMapper.selectByPrimaryKey(noticeId);
    }

    @Override
    public List<Map<String, Object>> getResultNumber() {
        return amsshipDeliveryNoticeMapper.getResultNumber();
    }
    //货权转移下拉框
    @Override
    public List<Map<String, Object>> getcarrier() {
        return amsshipDeliveryNoticeMapper.getcarrier();
    }
////采购订单号下拉框
//    @Override
//    public List<Map<String, Object>> getOrderNo() {
//        return amsshipDeliveryNoticeMapper.getOrderNo();
//    }

    @Override
    public List<Map<String, Object>> getShipper() {
        return amsshipDeliveryNoticeMapper.getShipper();
    }

    @Override
    public int updateByPrimaryKeySelective(AmsshipDeliveryNotice amsshipDeliveryNotice) {
        return amsshipDeliveryNoticeMapper.updateByPrimaryKeySelective(amsshipDeliveryNotice);
    }

    @Override
    public List<Map<String, Object>> selectByNoticeId(Integer noticeId) {
        return amsshipDeliveryNoticeMapper.selectByNoticeId(noticeId);
    }


}
