package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.model.TmsshipShipLocation;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.dil.model.OmsshipShipmentInstructions;
import com.steerinfo.dil.mapper.OmsshipShipmentInstructionsMapper;
import com.steerinfo.dil.service.IOmsshipShipmentInstructionsService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;


import java.math.BigDecimal;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * OmsshipShipmentInstructions服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-20 03:05
 * 类描述
 * 修订历史：
 * 日期：2021-08-20
 * 作者：generator
 * 参考：
 * 描述：OmsshipShipmentInstructions服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "omsshipShipmentInstructionsService")
public class OmsshipShipmentInstructionsServiceImpl implements IOmsshipShipmentInstructionsService {

    @Autowired
    private OmsshipShipmentInstructionsMapper omsshipShipmentInstructionsMapper;

    /**
     * 通过主键查询
     * @param shipmentInstructionsId
     * @return
     */
    @Override
    public OmsshipShipmentInstructions selectByKey(BigDecimal shipmentInstructionsId) {
        return omsshipShipmentInstructionsMapper.selectByPrimaryKey(shipmentInstructionsId);
    }

    /**
     * 展示所有装船指令
     * @param mapVal
     * @return
     */
    @Override
    public List<Map<String, Object>> selectAll(Map<String, Object> mapVal) {
        return omsshipShipmentInstructionsMapper.selectAll(mapVal);
    }

//    @Override
//    public int selectKey(BigDecimal shipmentInstructionsId) {
//        return omsshipShipmentInstructionsMapper.selectKey(shipmentInstructionsId);
//    }

    /**
     * 逻辑删除
     * @param shipmentInstructionsId
     * @return
     */
    @Override
    public int deleteByPrimaryKey(BigDecimal shipmentInstructionsId) {
        OmsshipShipmentInstructions omsshipShipmentInstructions = selectByKey(shipmentInstructionsId);
        omsshipShipmentInstructions.setDeleted(new BigDecimal(1));
        return omsshipShipmentInstructionsMapper.updateByPrimaryKeySelective(omsshipShipmentInstructions);
    }

    /**
     * 新增装船指令
     * @param omsshipShipmentInstructions
     * @return
     */
    @Override
    public int insert(OmsshipShipmentInstructions omsshipShipmentInstructions) {
        BigDecimal shipmentInstructionsId = omsshipShipmentInstructionsMapper.selectInstructionId();
        omsshipShipmentInstructions.setShipmentInstructionsId(shipmentInstructionsId);
        BigDecimal batchId = omsshipShipmentInstructions.getBatchId();
        Map<String,Object> map = omsshipShipmentInstructionsMapper.getPortAndPier(batchId);
        BigDecimal pierId = (BigDecimal) map.get("pierId");
        BigDecimal portId = (BigDecimal) map.get("portId");
        omsshipShipmentInstructions.setRecipientCarrierId(pierId);
        omsshipShipmentInstructions.setPortCarrierId(portId);
        //  设置常规字段
        omsshipShipmentInstructions.setInsertTime(new Date());
        omsshipShipmentInstructions.setDeleteName(null);
        omsshipShipmentInstructions.setDeleteTime(null);
        omsshipShipmentInstructions.setInsertUsername("admin");
        omsshipShipmentInstructions.setUpdateTime(new Date());
        omsshipShipmentInstructions.setInsertUpdateRemark("无");
        omsshipShipmentInstructions.setUpdateUsername("admin");
        omsshipShipmentInstructions.setDeleted(new BigDecimal(0));
        omsshipShipmentInstructions.setInstructionIssueStatus("未下发");
        return omsshipShipmentInstructionsMapper.insert(omsshipShipmentInstructions);
    }

    /**
     * 通过主键修改
     * @param omsshipShipmentInstructions
     * @return
     */
    @Override
    public int updateByPrimaryKey(OmsshipShipmentInstructions omsshipShipmentInstructions) {
        omsshipShipmentInstructions.setUpdateTime(new Date());
        return omsshipShipmentInstructionsMapper.updateByPrimaryKeySelective(omsshipShipmentInstructions);

    }

    @Override
    public BigDecimal selectMaxId() {
        return omsshipShipmentInstructionsMapper.selectMaxId();
    }

    /**
     * 查询装船指令表单
     * @param shipmentInstructionsId
     * @return
     */
    @Override
    public List<Map<String, Object>> selectShipmentInstructions(BigDecimal shipmentInstructionsId) {
        return omsshipShipmentInstructionsMapper.selectShipmentInstructions(shipmentInstructionsId);
    }

    /**
     * 修改下发状态
     * @param shipmentInstructionsId
     * @return
     */
    @Override
    public int updateIssueStatus(BigDecimal shipmentInstructionsId) {
        OmsshipShipmentInstructions omsshipShipmentInstructions = selectByKey(shipmentInstructionsId);
        omsshipShipmentInstructions.setInstructionIssueStatus("已下发");
        return omsshipShipmentInstructionsMapper.updateByPrimaryKeySelective(omsshipShipmentInstructions);
    }

    /**
     * 获得批次下拉框
     * @return
     */
    @Override
    public List<Map<String, Object>> getBatchId() {
        return omsshipShipmentInstructionsMapper.getBatchId();
    }
}
