package com.steerinfo.dil.service.impl;

import com.steerinfo.dil.feign.WmshboundFeign;
import com.steerinfo.dil.mapper.TmsshipEntryWharyResultMapper;
import com.steerinfo.dil.mapper.TmsshipOutWharyResultMapper;
import com.steerinfo.dil.model.TmsshipEntryWharyResult;
import com.steerinfo.dil.model.TmsshipOutWharyResult;
import com.steerinfo.dil.util.NoUtil;
import com.steerinfo.framework.mapper.IBaseMapper;
import com.steerinfo.framework.service.impl.BaseServiceImpl;
import com.steerinfo.dil.model.TmsshipLoadShipResult;
import com.steerinfo.dil.mapper.TmsshipLoadShipResultMapper;
import com.steerinfo.dil.service.ITmsshipLoadShipResultService;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import org.springframework.transaction.annotation.Transactional;

import java.math.BigDecimal;
import java.time.LocalDate;
import java.util.Date;
import java.util.HashMap;
import java.util.List;
import java.util.Map;

/**
 * TmsshipLoadShipResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 08:47
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmsshipLoadShipResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmsshipLoadShipResultService")
public class TmsshipLoadShipResultServiceImpl implements ITmsshipLoadShipResultService {

    @Autowired
    TmsshipLoadShipResultMapper tmsshipLoadShipResultMapper;
    @Autowired
    TmsshipTotalResultServiceImpl tmsshipTotalResultService;
    @Autowired
    TmsshipEntryWharyResultMapper tmsshipEntryWharyResultMapper;
    @Autowired
    TmsshipOutWharyResultMapper tmsshipOutWharyResultMapper;
    @Autowired
    WmshboundFeign wmshboundFeign;
    @Autowired
    NoUtil noUtil;

    /**
     * 新增抵港，离岗，装船实绩
     * @param map
     * @return
     */
    @Override
    @Transactional
    public int insertLoadShip(Map<String,Object> map) {
        Map<String,Object> mapVal = (Map<String, Object>) map.get("mapVal");
        Map<String,Object> rowMap = (Map<String, Object>) map.get("rowMap");
        TmsshipLoadShipResult tmsshipLoadShipResult = new TmsshipLoadShipResult();
        TmsshipEntryWharyResult tmsshipEntryWharyResult = new TmsshipEntryWharyResult();
        BigDecimal orderId = new BigDecimal((Integer) rowMap.get("orderId"));
        BigDecimal batchId = getBatchId(rowMap);
        Map<String,Object> ppMap = tmsshipLoadShipResultMapper.getPortAndPier(batchId);
        BigDecimal startPortId = (BigDecimal) ppMap.get("startPortId");
        BigDecimal arrivePortId = (BigDecimal) ppMap.get("arrivePortId");
        BigDecimal pierId = (BigDecimal) ppMap.get("pierId");
        Date noticeDeliveryTime = (Date) ppMap.get("noticeDeliveryTime");
        String resultMemo = (String) mapVal.get("resultMemo");
        // 抵港
        Date resultPortDeclarationTime = new Date((Long) mapVal.get("resultPortDeclarationTime"));
        String resultPortDeclarationName = (String) mapVal.get("resultPortDeclarationName");
        Date resultArrivalTime = new Date((Long)mapVal.get("resultArrivalTime"));
        BigDecimal totalResultId = tmsshipTotalResultService.getResultTotalId(orderId);
        tmsshipEntryWharyResult.setTotalResultId(totalResultId);
        BigDecimal resultEntryId = tmsshipEntryWharyResultMapper.selectEntryId();
        tmsshipEntryWharyResult.setResultId(resultEntryId);
        String resultEntryNumber = noUtil.setResultNo("DG",resultEntryId);
        tmsshipEntryWharyResult.setResultNumber(resultEntryNumber);
        tmsshipEntryWharyResult.setWharyId(pierId);
        tmsshipEntryWharyResult.setResultPortDeclarationTime(resultPortDeclarationTime);
        tmsshipEntryWharyResult.setResultPortDeclarationName(resultPortDeclarationName);
        tmsshipEntryWharyResult.setResultArrivalTime(resultArrivalTime);
        tmsshipEntryWharyResult.setResultMemo(resultMemo);
        // 设置常规字段
        tmsshipEntryWharyResult.setInsertTime(new Date());
        tmsshipEntryWharyResult.setUpdateTime(new Date());
        tmsshipEntryWharyResult.setInsertUsername("admin");
        tmsshipEntryWharyResult.setUpdateUsername("admin");
        tmsshipEntryWharyResult.setInsertUpdateRemark("无");
        tmsshipEntryWharyResult.setDeleteName(null);
        tmsshipEntryWharyResult.setDeleteTime(null);
        // 离港
        String resultOutWharyName = (String) mapVal.get("resultOutWharyName");
        Date resultOutWharyTime = new Date((Long) mapVal.get("resultOutWharyTime"));
        TmsshipOutWharyResult tmsshipOutWharyResult = new TmsshipOutWharyResult();
        tmsshipOutWharyResult.setTotalResultId(totalResultId);
        BigDecimal resultOutId = tmsshipOutWharyResultMapper.selectOutId();
        tmsshipOutWharyResult.setResultId(resultOutId);
        String resultOutNumber = noUtil.setResultNo("LG",resultOutId);
        tmsshipOutWharyResult.setResultNumber(resultOutNumber);
        tmsshipOutWharyResult.setWharyId(pierId);
        tmsshipOutWharyResult.setResultOutWharyTime(resultOutWharyTime);
        tmsshipOutWharyResult.setResultOutWharyName(resultOutWharyName);
        tmsshipOutWharyResult.setResultMemo(resultMemo);
        // 设置常规字段
        tmsshipOutWharyResult.setInsertTime(new Date());
        tmsshipOutWharyResult.setUpdateTime(new Date());
        tmsshipOutWharyResult.setInsertUsername("admin");
        tmsshipOutWharyResult.setUpdateUsername("admin");
        tmsshipOutWharyResult.setInsertUpdateRemark("无");
        tmsshipOutWharyResult.setDeleteName(null);
        tmsshipOutWharyResult.setDeleteTime(null);
        // 装船
        BigDecimal resultId = tmsshipLoadShipResultMapper.selectLoadId();
        BigDecimal resultActualInstallations = new BigDecimal((String) mapVal.get("resultActualInstallations"));
        BigDecimal rwarehouseMaterialId = new BigDecimal((Integer) mapVal.get("rwarehouseMaterialId"));
        Date resultLoadShipDate = new Date((Long) mapVal.get("resultLoadShipDate"));
        String resultIsClear = (String) mapVal.get("resultIsClear");
        String resultNumber = noUtil.setResultNo("ZC",resultEntryId);
        tmsshipLoadShipResult.setResultId(resultId);
        tmsshipLoadShipResult.setTotalResultId(totalResultId);
        tmsshipLoadShipResult.setLocationStartPortId(startPortId);
        tmsshipLoadShipResult.setArrivalPortId(arrivePortId);
        tmsshipLoadShipResult.setBatchId(batchId);
        tmsshipLoadShipResult.setResultDeliveryDate(noticeDeliveryTime);
        tmsshipLoadShipResult.setResultActualInstallations(resultActualInstallations);
        tmsshipLoadShipResult.setResultNumber(resultNumber);
        tmsshipLoadShipResult.setRwarehouseMaterialId(rwarehouseMaterialId);
        tmsshipLoadShipResult.setResultArrivalPortTime(resultArrivalTime);
        tmsshipLoadShipResult.setResultOutPortTime(resultOutWharyTime);
        tmsshipLoadShipResult.setResultLoadShipDate(resultLoadShipDate);
        tmsshipLoadShipResult.setResultIsclear(resultIsClear);
        // 设置常规字段
        tmsshipLoadShipResult.setInsertTime(new Date());
        tmsshipLoadShipResult.setInsertUsername("admin");
        tmsshipLoadShipResult.setInsertUpdateRemark("无");
        tmsshipLoadShipResult.setDeleteName(null);
        tmsshipLoadShipResult.setDeleteTime(null);
        tmsshipLoadShipResult.setUpdateTime(new Date());
        tmsshipLoadShipResult.setUpdateUsername("admin");
        tmsshipLoadShipResult.setDeleted(new BigDecimal(0));
        tmsshipEntryWharyResultMapper.insertSelective(tmsshipEntryWharyResult);
        tmsshipOutWharyResultMapper.insertSelective(tmsshipOutWharyResult);
        // 新增出库实绩
        Map<String,Object> mapValue = new HashMap<>();
        mapValue.put("batchId",batchId);
        mapValue.put("portId",startPortId);
        mapValue.put("resultTonnage",resultActualInstallations);
        mapValue.put("isClean",resultIsClear);
        wmshboundFeign.addResult(mapValue);
        int codeLoad = tmsshipLoadShipResultMapper.insertSelective(tmsshipLoadShipResult);
        return codeLoad;
    }

    /**
     * 根据主键删除装船
     * @param resultId
     * @return
     */
    @Override
    public int deleteLoadShip(BigDecimal resultId) {
        TmsshipLoadShipResult tmsshipLoadShipResult = selectLoadShip(resultId);
        tmsshipLoadShipResult.setDeleted(new BigDecimal(1));
        return tmsshipLoadShipResultMapper.updateByPrimaryKeySelective(tmsshipLoadShipResult);
    }

    /**
     * 根据主键查询装船
     * @param resultId
     * @return
     */
    @Override
    public TmsshipLoadShipResult selectLoadShip(BigDecimal resultId) {
        return tmsshipLoadShipResultMapper.selectByPrimaryKey(resultId);
    }

    /**
     * 根据主键修改
     * @param tmsshipLoadShipResult
     * @return
     */
    @Override
    public int updateLoadShip(TmsshipLoadShipResult tmsshipLoadShipResult) {
        tmsshipLoadShipResult.setUpdateTime(new Date());
        return tmsshipLoadShipResultMapper.updateByPrimaryKeySelective(tmsshipLoadShipResult);
    }

    /**
     * 查询所有装船信息
     * @param mapVal
     * @return
     */
    @Override
    public List<Map<String, Object>> selectLoadShipList(Map<String, Object> mapVal) {
        return tmsshipLoadShipResultMapper.selectLoadShipList(mapVal);
    }

    /**
     * 查询一条装船指令下的总重量
     * @param instructionsId
     * @return
     */
    @Override
    public BigDecimal selectAllWeight(BigDecimal instructionsId) {
        return tmsshipLoadShipResultMapper.selectAllWeight(instructionsId);
    }

    /**
     * 查询装船表单
     * @param resultId
     * @return
     */
    @Override
    public List<Map<String, Object>> getLoadShip(BigDecimal resultId) {
        return tmsshipLoadShipResultMapper.selectLoadShip(resultId);
    }

    /**
     * 根据物资名称和外轮船名得到批次
     * @param mapVal
     * @return
     */
    @Override
    public BigDecimal getBatchId(Map<String, Object> mapVal) {
        return tmsshipLoadShipResultMapper.getBatchId(mapVal);
    }
}
