package com.steerinfo.dil.service.impl;
import com.steerinfo.dil.model.TmsshipWaterQualityResult;
import com.steerinfo.dil.mapper.TmsshipWaterQualityResultMapper;
import com.steerinfo.dil.service.ITmsshipWaterQualityResultService;
import io.swagger.models.auth.In;
import org.springframework.beans.factory.annotation.Autowired;
import org.springframework.stereotype.Service;
import java.math.BigDecimal;
import java.util.Date;
import java.util.List;
import java.util.Map;

/**
 * TmsshipWaterQualityResult服务实现：
 * @author generator
 * @version 1.0-SNAPSHORT 2021-08-19 09:01
 * 类描述
 * 修订历史：
 * 日期：2021-08-19
 * 作者：generator
 * 参考：
 * 描述：TmsshipWaterQualityResult服务实现
 * @see null
 * @Copyright 湖南视拓信息技术股份有限公司. All rights reserved.
 */
@Service(value = "tmsshipWaterQualityResultService")
public class TmsshipWaterQualityResultServiceImpl implements ITmsshipWaterQualityResultService {

    @Autowired
    TmsshipWaterQualityResultMapper tmsshipWaterQualityResultMapper;
    @Autowired
    TmsshipLoadShipResultServiceImpl tmsshipLoadShipResultService;
    @Autowired
    TmsshipTotalResultServiceImpl tmsshipTotalResultService;

    /**
     * 查询最大id
     * @return
     */
    @Override
    public BigDecimal selectMaxId() {
        return tmsshipWaterQualityResultMapper.selectQualityId();
    }

    /**
     * 新增水分检测
     * @param map
     * @return
     */
    @Override
    public int insertWaterQualityResult(Map<String,Object> map) {
        Map<String,Object> mapVal = (Map<String, Object>) map.get("mapVal");
        Map<String,Object> waterQualityMap = (Map<String, Object>) map.get("waterQualityMap");
        TmsshipWaterQualityResult tmsshipWaterQualityResult = new TmsshipWaterQualityResult();
        BigDecimal resultId = selectMaxId();
        BigDecimal orderId = new BigDecimal((Integer) waterQualityMap.get("orderId"));
        BigDecimal instructionsId = selectInstructionsId(orderId);
        BigDecimal totalResultId = tmsshipTotalResultService.getResultTotalId(orderId);
        Date resultPlannedDate = new Date((Long) mapVal.get("resultPlannedDate"));
        Date resultCargoRightsDate = new Date((Long) mapVal.get("resultCargoRightsDate"));
        BigDecimal resultEmptyHeavyWaterMeter = new BigDecimal((String) mapVal.get("resultEmptyHeavyWaterMeter"));
        BigDecimal weights = tmsshipLoadShipResultService.selectAllWeight(instructionsId);
        BigDecimal resultActualInstallations = selectRealWeight(totalResultId);
        Double ratio = resultActualInstallations.doubleValue()/weights.doubleValue();
        String strRatio = ratio.toString();
        String shipmentRatio;
        if (strRatio.length() < 7) {
            shipmentRatio = strRatio;
        }
        else {
            shipmentRatio = strRatio.substring(0, 6);
        }
        BigDecimal resultShipmentRatio = new BigDecimal(shipmentRatio);
        Date resultEsDeliveryDate = tmsshipWaterQualityResultMapper.getDeliveryDate(orderId);
        BigDecimal resultWaterTonnage = new BigDecimal((String) mapVal.get("resultWaterTonnage"));
        BigDecimal resultInspectionFees = new BigDecimal((String) mapVal.get("resultInspectionFees"));
        Double content = resultWaterTonnage.doubleValue()/resultActualInstallations.doubleValue();
        String strContent = content.toString();
        String moistureContent;
        if (strContent.length() < 7) {
            moistureContent = strContent;
        }
        else {
            moistureContent = strContent.substring(0, 6);
        }
        BigDecimal resultMoistureContent = new BigDecimal(moistureContent);
        // 设置对象属性值
        tmsshipWaterQualityResult.setResultId(resultId);
        tmsshipWaterQualityResult.setTotalResultId(totalResultId);
        tmsshipWaterQualityResult.setResultPlannedDate(resultPlannedDate);
        tmsshipWaterQualityResult.setResultCargoRightsDate(resultCargoRightsDate);
        tmsshipWaterQualityResult.setResultShipmentRatio(resultShipmentRatio);
        tmsshipWaterQualityResult.setResultEmptyHeavyWaterMeter(resultEmptyHeavyWaterMeter);
        tmsshipWaterQualityResult.setResultMoistureContent(resultMoistureContent);
        tmsshipWaterQualityResult.setResultWaterTonnage(resultWaterTonnage);
        tmsshipWaterQualityResult.setResultInspectionFees(resultInspectionFees);
        tmsshipWaterQualityResult.setResultEsDeliveryDate(resultEsDeliveryDate);
        // 设置常规字段
        tmsshipWaterQualityResult.setInsertTime(new Date());
        tmsshipWaterQualityResult.setInsertUsername("admin");
        tmsshipWaterQualityResult.setInsertUpdateRemark("无");
        tmsshipWaterQualityResult.setUpdateTime(new Date());
        tmsshipWaterQualityResult.setUpdateUsername("admin");
        tmsshipWaterQualityResult.setDeleteName(null);
        tmsshipWaterQualityResult.setDeleteTime(null);
        tmsshipWaterQualityResult.setDeleted(new BigDecimal(0));
        return tmsshipWaterQualityResultMapper.insert(tmsshipWaterQualityResult);
    }

    /**
     * 通过主键删除水分质检
     * @param resultId
     * @return
     */
    @Override
    public int deleteWaterQualityResult(BigDecimal resultId) {
        TmsshipWaterQualityResult tmsshipWaterQualityResult = selectWaterQualityResult(resultId);
        tmsshipWaterQualityResult.setDeleted(new BigDecimal(1));
        return tmsshipWaterQualityResultMapper.updateByPrimaryKeySelective(tmsshipWaterQualityResult);
    }

    /**
     * 通过主键查询水分质检
     * @param resultId
     * @return
     */
    @Override
    public TmsshipWaterQualityResult selectWaterQualityResult(BigDecimal resultId) {
        return tmsshipWaterQualityResultMapper.selectByPrimaryKey(resultId);
    }

    /**
     * 修改水分质检信息
     * @param tmsshipWaterQualityResult
     * @return
     */
    @Override
    public int updateWaterQualityResult(TmsshipWaterQualityResult tmsshipWaterQualityResult) {
        tmsshipWaterQualityResult.setUpdateTime(new Date());
        return tmsshipWaterQualityResultMapper.updateByPrimaryKeySelective(tmsshipWaterQualityResult);
    }

    /**
     * 查询所有水分质检信息
     * @param mapVal
     * @return
     */
    @Override
    public List<Map<String, Object>> selectWaterQualityList(Map<String, Object> mapVal) {
        return tmsshipWaterQualityResultMapper.selectWaterQualityList(mapVal);
    }

    /**
     * 查询所有水分质检表单
     * @param resultId
     * @return
     */
    @Override
    public List<Map<String, Object>> getWaterQuality(BigDecimal resultId) {
        return tmsshipWaterQualityResultMapper.selectWaterQuality(resultId);
    }

    /**
     * 通过总实绩id查询装船的实际重量
     * @param totalResultId
     * @return
     */
    @Override
    public BigDecimal selectRealWeight(BigDecimal totalResultId) {
        return tmsshipWaterQualityResultMapper.selectRealWeight(totalResultId);
    }

    /**
     * 通过子表id查询指令id
     * @param orderId
     * @return
     */
    @Override
    public BigDecimal selectInstructionsId(BigDecimal orderId) {
        return tmsshipWaterQualityResultMapper.selectInstructionsId(orderId);
    }
}
